String beginsWith := method(s, s == slice(0, s size))
String endsWith := method(s, s == slice(size - s size, size))

Completion := Object clone do(
  openers := Map clone atPut(")","(") atPut("}","{") atPut("]","[")
  lastCommandOf := method(str,
    inString := nil
    inComment := nil
    braces := list
    stack := list(0)
    for(i, 0, str size - 1,
      c := str slice(i,i+1)
      if (inComment and c=="\n",
        inComment = nil; continue)
      if (inString and c=="\"" and str slice(i-1,i)  != "\\", 
        inString = nil; continue)
      if (c == "#" or c=="/" and i != (str size - 1) and str slice(i+1,i+2) == "/",
        inComment = 1; continue)
      if (c == "(" or c=="{" or c=="[",
        stack push(i+1)
        braces push(c))
      if (c == ")" or c=="}" or c=="]",
        if (braces pop != openers at(c), return nil, stack pop))
      if (c == ";" or c=="\n" or c==",",
        stack pop
        stack push(i + 1))
    )
    if (inString or inComment, return nil)
    command := str slice(stack pop)
  )
    
  complete := method(str, context,
    command := lastCommandOf(str asMutable strip(" "))
    if (command isNil, return list)
    
    try(
      msg := message(thisContext) setAttachedMessage( command asMessage )
    ) catch (
      return list
    )
    prefix := ""

    if (command endsWithSeq(" ") not,
      while (msg attachedMessage attachedMessage, msg = msg attachedMessage)
      prefix = msg attachedMessage name
      msg setAttachedMessage(nil)
    )

    res := softEval(context, msg)
    if (res,
      slots := allSlotNamesOf(res) select(i,v, v beginsWithSeq(prefix))
      slots = slots map (i,v, v slice(prefix size)) sort
    ,
      list)
  )
  
  // Tries to evaluate msg in context without doing anything that might
  // cause side effects.
  // If successful, returns the result
  // Else, returns nil
  softEval := block(context, msg,
    if (msg name == "" and msg arguments size == 0, return nil)
    obj := context
    while (msg,
      if (msg name asNumber) then (
        obj = msg name asNumber
      ) elseif (msg name beginsWithSeq("\"") and msg name endsWithSeq("\"")) then (
        obj = msg name asMutable unescape
      ) else (
        if (theslot := context getSlot( msg name ) ) then (
          if (msg name == "thisContext",
            obj = context
            ,
            if (theslot type == "CFunction",
              return nil
              ,
              if (theslot type == "Block",
                return nil
                ,
                obj = theslot
              )
            )
          )
        ) else (
          return nil
        )
      )
      msg = msg attachedMessage
    )
    return obj
  )
  
  allSlotNamesOf := block(obj,
    if (obj != Object,
      names := List clone
      obj protos foreach(i, v, names appendSeq(allSlotNamesOf(v)))
    ,
      names := list)
    obj slotNames foreach(i,v, if( names contains(v) not, names append(v)))
    return names
  )

  // IoFE doComplete code.
  //  * Prints if there are multiple results, returns nil
  //  * If there is one result, returns string containing result.
  //  * If there are no results, returns nil
  doComplete := block(msg,
    result := complete(msg, Lobby)

    if (result size == 0, return nil)
    if (result size == 1, return result at(0))

    "\n" print
    for (i, 0, result size - 1,
      result at(i) print
      " " print
    )
    "\n" print
    return nil
  )

)
